﻿using System.Diagnostics;
using ArtOfTest.WebAii.Core;
using TechTalk.SpecFlow;

namespace Specflow_HelloWorld
{
    [Binding]
    public class Hooks
    {
        public static bool PreviousTestFailed = false;

        [BeforeScenario]
        public void BeforeScenario()
        {
            if (PreviousTestFailed)
            {
                CleanUpAfterFailedTest();
            }
            
            if (Manager.Current == null)
            {
                Manager myMgr = new Manager(new Settings());

                myMgr.Settings.Web.EnableSilverlight = true;
                myMgr.Settings.Web.RecycleBrowser = true;
                myMgr.Settings.ElementWaitTimeout = 20000;
                myMgr.Settings.WaitCheckInterval = 100;
                myMgr.Settings.ExecutionDelay = 0;

                myMgr.Start();
                myMgr.LaunchNewBrowser();
            }
        }

        [AfterScenario]
        public void AfterScenario()
        {
            if (ScenarioContext.Current.TestError != null)
            {
                PreviousTestFailed = true;
            }
            else
            {
                PreviousTestFailed = false;
            }
        }

        [AfterTestRun]
        public static void AfterTestRun() 
        {
            Manager.Current.Dispose();
        }

        public static void CleanUpAfterFailedTest() 
        {            
            // Close all running IEs
            foreach (var process in Process.GetProcessesByName("iexplore"))
            {
                try
                {
                    process.Kill();
                }
                catch { }
            }
            Manager.Current.Dispose();
        }
    }
}
